package model.dominio;

import model.dominio.eventi.Start;
import model.dominio.eventi.Corri;
import model._gestioneeventi.Evento;
import model._gestioneeventi.Environment;
import model._framework.Task;
import java.util.*;

import model.dominio.Ciclista.Stato;


public class CiclistaFired implements Task {
  private boolean eseguita = false;
  private Ciclista ciclista;
  private Evento evento;

  public CiclistaFired(Ciclista ciclista, Evento evento) {
    this.ciclista = ciclista;
    this.evento = evento;
  }

  public synchronized void esegui() {
    if (eseguita
        || (evento.getDestinatario() != ciclista && evento.getDestinatario() != null)
        || ciclista.getLinkPartecipa() == null // Verifica precondizione
    ) {
      return;
    }
    eseguita = true;

    switch (ciclista.getStato()) {
    case PRONTO:
      
      break; // case PRONTO

    case IN_GARA:
      
      break; // case IN_GARA

    case IN_TESTA:
      
      break; // case IN_TESTA

    default:
      throw new RuntimeException("Stato corrente non riconosciuto.");
    }// switch (ciclista.getStato())
  }

  private void aggiornaKmPercorsi(float nuovaDistanza) {
    // Metodo (privato) di servizio
    /*
     * Rimpiazza il link esistente tra gara e ciclista con uno equivalente tale
     * che kmPercorsi = nuovaDistanza
     */
    
  }

  private boolean primo() {
    // Metodo (privato) di servizio
    /*
     * Calcola la condizione primo Restituisce true se e solo se il ciclista ha
     * percorso la distanza massima tra i partecipanti alla sua stessa gara
     */

    
  }

  private boolean arrivato() {
    // Metodo (privato) di servizio
    /*
     * Calcola la condizione arrivato
     * Restituisce true se e solo se esiste un
     * ciclista che ha percorso tutto il tratto partenza-traguardo della gara a
     * cui partecipa il cilista corrente
     */

    
  }

  public synchronized boolean estEseguita() {
    return eseguita;
  }

}
